unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ReportThreadTerminate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses uReportThread;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  MyReport: AdvancedReportThread;
begin
  MyReport := AdvancedReportThread.Create;

  Memo1.Lines.LoadFromFile('template.dat');

  MyReport.FTemplateData := Memo1.Text;
  MyReport.fClientData := Memo2.Text;
  MyReport.FClientDataSets := Memo3.Text;

  MyReport.FOutputFormat := 'PDF';
  MyReport.FOutputFilename := ExtractFilePath(Application.ExeName) +
    'chart_report.pdf';

  MyReport.OnTerminate := ReportThreadTerminate;

  MyReport.Start;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  MyReport: AdvancedReportThread;
begin
  MyReport := AdvancedReportThread.Create;

  Memo1.Lines.LoadFromFile('template_no_charts.dat');

  MyReport.FTemplateData := Memo1.Text;
  MyReport.fClientData := Memo2.Text;
  MyReport.FClientDataSets := Memo3.Text;

  MyReport.FOutputFormat := 'PDF';
  MyReport.FOutputFilename := ExtractFilePath(Application.ExeName) +
    'no_chart_report.pdf';

  MyReport.OnTerminate := ReportThreadTerminate;

  MyReport.Start;
end;

procedure TForm1.ReportThreadTerminate(Sender: TObject);
begin
  ShowMessage('Done, report created');
end;

end.
